#include <bits/stdc++.h>

using namespace std;
long long mas[32005], mas1[32005];
vector<pair<long long, long long>> v;
int main()
{
  long long n;
  cin>>n;
  for(int i=0; i<n; i++)
  {
      cin>>mas[i];
      mas1[i] = mas[i];
  }
  sort(mas1, mas1+n);

  for(int i=0; i<n; i++)
  {
      if(mas1[i] != mas[i])
      {
          long long l=0;
          for(int j=i; j<n; j++)
           if(mas[j] == mas1[i])
          {
              l=j; break;
          }

          v.push_back(make_pair(i, l));
          reverse(mas+i, mas+l+1);

      }
  }
  cout<<v.size()<<'\n';
  for(int i=0; i<v.size(); i++)
    cout<<v[i].first+1<<' '<<v[i].second+1<<'\n';
}

